package massim;

import java.io.*;
import javax.xml.transform.*;
import javax.xml.transform.dom.*;
import javax.xml.transform.stream.*;
import org.w3c.dom.*;

import static massim.util.DebugLog.*;
import java.util.*;

public class XMLFileWriter implements java.util.Observer {
	private File file;
	private Transformer transformer;

	public XMLFileWriter() {
		try {
			transformer = TransformerFactory.newInstance().newTransformer();
			transformer.setOutputProperty(OutputKeys.INDENT,"yes");
		} catch (TransformerConfigurationException e) {
			log(LOGLEVEL_CRITICAL,"error: Unable to instantiate XML transformer. Aborting...");
			e.printStackTrace();
		}
	}
	
	public void setFile(File file) {
		this.file = file;
	}
	
	public File getFile() {
		return file;
	}
	
	public void update(Observable o, Object arg) {
		XMLOutputObserver obs = (XMLOutputObserver) o; 
		try {
			transformer.transform(new DOMSource(obs.getDocument()), new StreamResult(new FileOutputStream(getFile())));
		} catch (FileNotFoundException e) {
			log(LOGLEVEL_ERROR,"warning: unable to open file for writing");
			e.printStackTrace();
		} catch (TransformerException e) {
			log(LOGLEVEL_ERROR,"warning: transformer error");
			e.printStackTrace();
		}
	}
}
