package massim.visualization;

import massim.svg.SvgXmlFile;

import org.apache.batik.dom.svg.SVGDOMImplementation;
import org.w3c.dom.CDATASection;
import org.w3c.dom.DOMImplementation;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.Text;

public class PreviewSvg extends SvgXmlFile {
	private String imageHeight;
	private String imageWidth;
	private String namePreviewSvg;
	private String nameOutputFile;
	private Document configDocument;

	private void setDefaultValues() {
		MainPolicy mainPolicy = new MainPolicy();
		this.namePreviewSvg = mainPolicy.getNamePreviewSvg();
		this.nameOutputFile = mainPolicy.getNameOutputFile();
		// this.path = mainPolicy.getOutPut();
	}

	public void setImageHeight(String imageHeight) {
		this.imageHeight = imageHeight;
	}

	public void setImageWidth(String imageWidth) {
		this.imageWidth = imageWidth;
	}

	public String readSvgConf() {
		/* need name / path to the config - file */
		MainPolicy mainPolicy = new MainPolicy();
		String configPath = mainPolicy.getConfigFile();
		setDefaultValues();

		String image = "no";
		SvgXmlFile config = new SvgXmlFile();
		configDocument = config.openFile(configDocument, configPath);
		Node root = configDocument.getDocumentElement();

		int length = root.getChildNodes().getLength();
		for (int i = 0; i < length; i++) {
			Node configElement = root.getChildNodes().item(i);

			if ((configElement.getNodeName() == "simulationOutput")) {
				Element simulationConfig = (Element) configDocument
						.getElementsByTagName("simulationOutput").item(0);
				int numberAttributes = configElement.getAttributes()
						.getLength();
				for (int j = 0; j < numberAttributes; j++) {
					// get the path if define in config file
					// if (configElement.getAttributes().item(j).getNodeName()
					// == "path") {
					// path = simulationConfig.getAttribute("path");
					// } else
					// // get the name of the output files if define in config
					// file
					if (configElement.getAttributes().item(j).getNodeName() == "nameOutputFile") {
						nameOutputFile = simulationConfig
								.getAttribute("nameOutputFile");
					} else if (configElement.getAttributes().item(j)
							.getNodeName() == "namePreviewSvg") {

						namePreviewSvg = simulationConfig
								.getAttribute("namePreviewSvg");
					} else {
						// do nothing wrong entry in config file
					}
				}
			}
			if ((configElement.getNodeName() == "imageSize")) {
				image = "yes";
				Element simulationConfig = (Element) configDocument
						.getElementsByTagName("imageSize").item(0);
				int numberAttributes = configElement.getAttributes()
						.getLength();
				for (int j = 0; j < numberAttributes; j++) {
					if (configElement.getAttributes().item(j).getNodeName() == "height")
						imageHeight = (simulationConfig.getAttribute("height"));
					else if (configElement.getAttributes().item(j)
							.getNodeName() == "width")
						imageWidth = (simulationConfig.getAttribute("width"));
				}
			}
		}
		/* add the svg ending .svg to the name of the control/preview file */
		namePreviewSvg = namePreviewSvg + svgEnding;
		return image;
	}

	/**
	 * generate the PreviewSvg its the main SVG in the visualisation, with the
	 * control panal, the main title and import all generated svg's
	 * 
	 * @param numberSvg
	 *            is the number of generated svg files
	 * @param headInformationFirstLevel
	 *            text in head of the svg file
	 * @param headInformationSecondLevel
	 *            text in subhead of the svg file
	 */
	public void createPreviewSvg(String path, long numberSvg,
			String headInformationFirstLevel, String headInformationSecondLevel) {
		readSvgConf();
		DOMImplementation impl = SVGDOMImplementation.getDOMImplementation();
		// we are using a constant available on the SVGDOMImplementation
		// but we could have used "http://www.w3.org/2000/svg"

		String svgNS = SVGDOMImplementation.SVG_NAMESPACE_URI;
		Document doc = impl.createDocument(svgNS, "svg", null);

		Element svgRoot = doc.getDocumentElement();
		svgRoot.setAttribute("onload", "start()");

		Element title = doc.createElement("title");
		Text theTitle = doc.createTextNode("Show Simulation");
		title.appendChild(theTitle);
		svgRoot.appendChild(title);

		Element script = doc.createElement("script");
		script.setAttribute("type", "text/ecmascript");

		String arraySVGs = "";

		for (int i = 0; i <= numberSvg; i++) {
			if (i != 0) {
				arraySVGs = arraySVGs + ", ";
			}
			arraySVGs = arraySVGs + "\"" + nameOutputFile + "-" + i + ".svg"
					+ "\"";
		}

		String myScript = "var dia=new Array ("
				+ arraySVGs
				+ ");\n"
				+ "var numberSvgs="
				+ numberSvg
				+ ";\n"
				+ "var stat=\"stop\";\n"
				+ "var a=0;\n"
				+ "var time=0;\n"
				+ "var delay = 1000;\n"
				+ "var zoomX = 1;\n"
				+ "var zoomY = 1;\n"
				+ "\n"
				+
				// "function callback(evt) {\n" +
				// " if (evt.target.requestState == URLRequest.COMPLETED &&
				// evt.target.status == 200) {\n" +
				// " alert(\"OK: \" + evt.target.responseText);\n" +
				// " } else {\n" +
				// " alert(\"ERROR!\");\n" +
				// " }\n" +
				// "}\n" +
				// "function getURL(url, callback) {\n" +
				// " var req = createURLRequest();\n" +
				// " req.addEventListener(\"URLResponse\", callback, false);\n"
				// +
				// " req.init(\"GET\", url);\n" +
				// " req.submit();\n" +
				// "}\n" +
				"function start() {\n"
				+ "  var textobject = document.createElement(\"text\");\n"
				+ "  textobject.setAttribute(\"id\",\"text\");\n"
				+ "  document.getFirstChild().appendChild(textobject);\n"
				+ "  createText();\n"
				+ "\n"
				+ "  var speedTextObject = document.createElement(\"text\");\n"
				+ "  speedTextObject.setAttribute( \"id\", \"text2\");\n"
				+ "  document.getFirstChild().appendChild(speedTextObject);\n"
				+ "  pressSpeedButton(1,1);\n"
				+ "}\n \n"
				+ "function createText() {\n"
				+ "  var t = document.getElementById('text');\n"
				+ "  document.getFirstChild().removeChild(t);\n"
				+ "  var step = a;\n"
				+ "  var textnode = document.createTextNode(step +\" / \"+ numberSvgs);\n"
				+ "  var textobject = document.createElement(\"text\");\n"
				+ "  textobject.setAttribute(\"id\",\"text\");\n"
				+ "  textobject.setAttribute(\"x\",\"10\");\n"
				+ "  textobject.setAttribute(\"y\",\"588\");\n"
				+ "  textobject.setAttribute(\"style\",\"font-family:Arial Unicode;font-weight:bold;font-size:30;\");\n"
				+ "  textobject.setAttribute(\"transform\",\"scale(\"+zoomX+\" \"+zoomY+\")\");\n"
				+ "  textobject.appendChild(textnode);\n"
				+ "  document.getFirstChild().appendChild(textobject);\n"
				+ "}\n \n"
				+ "function nextSvg() {\n"
				+ "  if (a==(numberSvgs)){\n"
				+ "    a=0;\n"
				+ "  }\n"
				+ "  else {\n"
				+ "    a++;\n"
				+ "  }\n"
				+ "  createText();\n"
				+ "  var img = document.getElementById('image');\n"
				+ "  img.setAttribute('xlink:href',dia[a]);\n"
				+ "}\n \n"
				+ "function backSvg() {\n"
				+ "  if (a==0 || a < 0) {\n"
				+ "    a=numberSvgs;\n"
				+ "  }\n"
				+ "  else {\n"
				+ "    a--;\n"
				+ "  }\n"
				+ "  createText();\n"
				+ "  var img = document.getElementById('image');\n"
				+ "  img.setAttribute('xlink:href',dia[a]);\n"
				+ "}\n \n"
				+ "function firstSvg() {\n"
				+ "  var img = document.getElementById('image');\n"
				+ "  a = 0;\n"
				+ "  createText();\n"
				+ "  stat = \"stop\";"
				+ "  img.setAttribute('xlink:href',dia[a]);\n"
				+ "}\n \n"
				+ "function lastSvg() {\n"
				+ "  var img = document.getElementById('image');\n"
				+ "  a = numberSvgs;\n"
				+ "  createText();\n"
				+ "  img.setAttribute('xlink:href',dia[a]);\n"
				+ "}\n \n"
				+ "function _run() { \n"
				+ "  if(stat == \"start\") { \n"
				+ "    if(a < numberSvgs) { \n"
				+ "      a = -1;\n"
				+ "    } \n"
				+ "  } \n"
				+ "  if(stat == \"stop\") { \n"
				+ "    if(a < numberSvgs) { \n"
				+ "      stat = \"start\"; \n"
				+ "      load(); \n"
				+ "    } \n"
				+ "    if(a == numberSvgs) {\n"
				+ "      stat = \"start\";\n"
				+ "      a = -1;\n"
				+ "      load();\n"
				+ "    } \n"
				+ "  } \n"
				+ "  if(stat == \"halt\") { \n"
				+ "    stat = \"start\"; \n"
				+ "    load();\n"
				+ "  } \n"
				+ "} \n \n"
				+ "function load() {\n"
				+ "  if(stat == \"start\" && a < (numberSvgs)) {\n"
				+ "    a++;\n"
				+ "    var img = document.getElementById('image');\n"
				+ "    createText();\n"
				+ "    img.setAttribute('xlink:href',dia[a]);\n"
				+
				// " getURL(dia[a+1],callback);\n" +
				"    setTimeout(\"load()\",delay);\n"
				+ "  } else if ( a == numberSvgs) {\n"
				+ "    stat = \"stop\";\n"
				+ "  }\n"
				+ "}\n \n"
				+ "function _halt() {\n"
				+ "  stat = \"halt\";\n"
				+ "  load();\n"
				+ "}\n \n"
				+ "function speedPlus() {\n"
				+ "  if(delay > 32) { \n"
				+ "    delay = delay / 2; \n"
				+ "  } \n"
				+ "  pressSpeedButton(zoomX,zoomY);"
				+ "}\n \n"
				+ "function speedMinus() {\n"
				+ "  if(delay < 7999) { \n"
				+ "    delay = delay * 2;\n"
				+ "  } \n"
				+ "  pressSpeedButton(zoomX,zoomY);"
				+ "}\n \n"
				+ "function pressSpeedButton(zoomX,zoomY) {\n"
				+ "  var t = document.getElementById('text2');\n"
				+ "  document.getFirstChild().removeChild(t);\n"
				+ "  var speedTextNode = document.createTextNode((1000 / delay)+\"  frames per second\");\n"
				+ "  var speedTextObject = document.createElement(\"text\");\n"
				+ "  speedTextObject.setAttribute( \"id\", \"text2\");\n"
				+ "  speedTextObject.setAttribute(\"x\", \"773\");\n"
				+ "  speedTextObject.setAttribute( \"y\", \"588\");\n"
				+ "  speedTextObject.setAttribute(\"style\",\"font-family:Arial Unicode;font-weight:bold;font-size:16;\");\n"
				+ "  speedTextObject.setAttribute(\"transform\",\"scale(\"+zoomX+\" \"+zoomY+\")\");\n"
				+ "  speedTextObject.appendChild(speedTextNode);\n"
				+ "  document.getFirstChild().appendChild(speedTextObject);\n"
				+ "}\n \n"
				+
				// this function is for zooming, that mean here different
				// resolutions 800x600, 1024x768 ...
				"function zoom(x,y) {\n"
				+ "  var img = document.getElementById('zooming');\n"
				+ "  img.setAttribute('transform','scale('+x+' '+y+')');\n"
				+ "  zoomX = x;\n" + "  zoomY = y;\n" + "  createText();\n"
				+ "  pressSpeedButton(zoomX,zoomY);" + "}\n \n"
				+ "function stoperror() { \n" + "  return true\n" + "}\n \n"
				+ "window.onerror=stoperror \n";
		CDATASection cdata1 = doc.createCDATASection(myScript);
		script.appendChild(cdata1);
		svgRoot.appendChild(script);

		// define the style for the menu - popup for choosing the resolution
		Element defs = doc.createElement("defs");
		Element style = doc.createElement("style");
		style.setAttribute("type", "text/css");

		String myStyle = "" + "rect {\n" + "  fill: rgb(140,140,140); \n"
				+ "}\n" + ".press{\n" + "  cursor: crosshair;\n" + "}\n"
				+ ".noPress{\n" + "  cursor: default;\n" + "}\n"
				+ ".control{\n" + "" + "  stroke:black;stroke-width:3;\n" + "}"
				+ ".menu{\n" + "  stroke:black;stroke-width:1.5;\n" + "}\n"
				+ ".special {\n" + "  fill: black;\n" + "  font-size: 12;\n"
				+ "}\n" + ".menuText {\n" + "  fill: gold;\n"
				+ "  font-size: 9;\n" + "}\n" + "text {\n"
				+ "  font-family:Arial Unicode;\n" + "}\n";
		CDATASection cdata2 = doc.createCDATASection(myStyle);
		style.appendChild(cdata2);
		defs.appendChild(style);
		svgRoot.appendChild(defs);

		// the main group which need for scaling the hole svg; default is
		// scale(1 1) == 1024x768
		Element mainGroup = doc.createElement("g");
		mainGroup.setAttribute("id", "zooming");
		mainGroup.setAttribute("transform", "scale(1 1)");

		// generate the text one the top (first line)
		Text headTextFirst = doc.createTextNode(headInformationFirstLevel);
		Element headTextElement1 = doc.createElement("text");
		headTextElement1.setAttribute("x", "506");
		headTextElement1.setAttribute("y", "17");// font-family:Arial;font-style:oblique;
		headTextElement1.setAttribute("style",
				"font-family:Arial Unicode;font-size:20;");
		headTextElement1.setAttribute("text-anchor", "middle");
		headTextElement1.appendChild(headTextFirst);
		mainGroup.appendChild(headTextElement1);

		// generate the text one the top (second line)
		Text headTextSecond = doc.createTextNode(headInformationSecondLevel);
		Element headTextElement2 = doc.createElement("text");
		headTextElement2.setAttribute("x", "506");
		headTextElement2.setAttribute("y", "37");// font-family:Arial;font-style:oblique;
		headTextElement2.setAttribute("style",
				"font-family:Arial Unicode;font-size:20;");
		headTextElement2.setAttribute("text-anchor", "middle");
		headTextElement2.appendChild(headTextSecond);
		mainGroup.appendChild(headTextElement2);

		Element controlGroup = doc.createElement("g");
		controlGroup.setAttribute("id", "controlGroup");
		controlGroup.setAttribute("class", "press");

		// first button
		Element rect1 = doc.createElement("rect");
		rect1.setAttribute("id", "rectFirstButton");
		rect1.setAttribute("x", "397");
		rect1.setAttribute("y", "570");
		rect1.setAttribute("width", "34");
		rect1.setAttribute("height", "20");
		rect1.setAttribute("rx", "5");
		rect1.setAttribute("ry", "5");
		rect1.setAttribute("class", "control");
		rect1.setAttribute("onclick", "firstSvg()");
		Element path1 = doc.createElement("path");
		path1.setAttribute("id", "pathFirstButton");
		path1
				.setAttribute("d",
						"M402 588 L402 572 M416 588 L406 580 L416 572 M426 588 L416 580 L426 572");
		path1.setAttribute("style", "stroke:black;stroke-width:3;fill:none;");
		path1.setAttribute("onclick", "firstSvg()");
		controlGroup.appendChild(rect1);
		controlGroup.appendChild(path1);

		// back button
		Element rect2 = doc.createElement("rect");
		rect2.setAttribute("id", "rectBackButton");
		rect2.setAttribute("x", "437");
		rect2.setAttribute("y", "570");
		rect2.setAttribute("width", "30");
		rect2.setAttribute("height", "20");
		rect2.setAttribute("rx", "5");
		rect2.setAttribute("ry", "5");
		rect2.setAttribute("class", "control");
		rect2.setAttribute("onclick", "backSvg()");
		Element path2 = doc.createElement("path");
		path2.setAttribute("id", "pathBackButton");
		path2.setAttribute("d",
				"M452 588 L442 580 L452 572 M462 588 L452 580 L462 572");
		path2.setAttribute("style", "stroke:black;stroke-width:3;fill:none;");
		path2.setAttribute("onclick", "backSvg()");
		controlGroup.appendChild(rect2);
		controlGroup.appendChild(path2);

		// halt button
		Element rect3 = doc.createElement("rect");
		rect3.setAttribute("id", "rectHaltButton");
		rect3.setAttribute("x", "473");
		rect3.setAttribute("y", "570");
		rect3.setAttribute("width", "30");
		rect3.setAttribute("height", "20");
		rect3.setAttribute("rx", "5");
		rect3.setAttribute("ry", "5");
		rect3.setAttribute("class", "control");
		rect3.setAttribute("onclick", "_halt()");
		Element line1 = doc.createElement("line");
		line1.setAttribute("id", "line1HaltButton");
		line1.setAttribute("x1", "493");
		line1.setAttribute("x2", "493");
		line1.setAttribute("y1", "572");
		line1.setAttribute("y2", "588");
		line1.setAttribute("style", "stroke:black;stroke-width:5;fill:none;");
		line1.setAttribute("onclick", "_halt()");
		Element line2 = doc.createElement("line");
		line2.setAttribute("id", "line2HaltButton");
		line2.setAttribute("x1", "483");
		line2.setAttribute("x2", "483");
		line2.setAttribute("y1", "572");
		line2.setAttribute("y2", "588");
		line2.setAttribute("style", "stroke:black;stroke-width:5;fill:none;");
		line2.setAttribute("onclick", "_halt()");
		controlGroup.appendChild(rect3);
		controlGroup.appendChild(line1);
		controlGroup.appendChild(line2);

		// play button
		Element rect4 = doc.createElement("rect");
		rect4.setAttribute("id", "rectPlayButton");
		rect4.setAttribute("x", "509");
		rect4.setAttribute("y", "570");
		rect4.setAttribute("width", "30");
		rect4.setAttribute("height", "20");
		rect4.setAttribute("rx", "5");
		rect4.setAttribute("ry", "5");
		rect4.setAttribute("class", "control");
		rect4.setAttribute("onclick", "_run()");
		Element poly5 = doc.createElement("polygon");
		poly5.setAttribute("id", "pathPlayButton");
		poly5.setAttribute("points", "516,573 516,587 532,580");
		poly5.setAttribute("style", "stroke:black;stroke-width:3;fill:black;");
		poly5.setAttribute("onclick", "_run()");
		controlGroup.appendChild(rect4);
		controlGroup.appendChild(poly5);

		// next Button
		Element rect6 = doc.createElement("rect");
		rect6.setAttribute("id", "rectNextButton");
		rect6.setAttribute("x", "545");
		rect6.setAttribute("y", "570");
		rect6.setAttribute("width", "30");
		rect6.setAttribute("height", "20");
		rect6.setAttribute("rx", "5");
		rect6.setAttribute("ry", "5");
		rect6.setAttribute("class", "control");
		rect6.setAttribute("onclick", "nextSvg()");
		Element path6 = doc.createElement("path");
		path6.setAttribute("id", "pathNextButton");
		path6.setAttribute("d",
				"M560 588 L570 580 L560 572 M550 588 L560 580 L550 572");
		path6.setAttribute("style", "stroke:black;stroke-width:3;fill:none;");
		path6.setAttribute("onclick", "nextSvg()");
		controlGroup.appendChild(rect6);
		controlGroup.appendChild(path6);

		// Last Button
		Element rect7 = doc.createElement("rect");
		rect7.setAttribute("id", "rectLastButton");
		rect7.setAttribute("x", "581");
		rect7.setAttribute("y", "570");
		rect7.setAttribute("width", "34");
		rect7.setAttribute("height", "20");
		rect7.setAttribute("rx", "5");
		rect7.setAttribute("ry", "5");
		rect7.setAttribute("class", "control");
		rect7.setAttribute("onclick", "lastSvg()");
		Element path7 = doc.createElement("path");
		path7.setAttribute("id", "pathLastButton");
		path7
				.setAttribute("d",
						"M610 588 L610 572 M596 588 L606 580 L596 572 M586 588 L596 580 L586 572");
		path7.setAttribute("style", "stroke:black;stroke-width:3;fill:none;");
		path7.setAttribute("onclick", "lastSvg()");
		controlGroup.appendChild(rect7);
		controlGroup.appendChild(path7);

		// Speed Button
		Element rect8 = doc.createElement("rect");
		rect8.setAttribute("id", "SpeedButton");
		rect8.setAttribute("x", "621");
		rect8.setAttribute("y", "570");
		rect8.setAttribute("width", "94");
		rect8.setAttribute("height", "20");
		rect8.setAttribute("rx", "5");
		rect8.setAttribute("ry", "5");
		rect8.setAttribute("class", "noPress");
		rect8.setAttribute("class", "control");
		Text theText = doc.createTextNode("PlaySpeed");
		Element speedText = doc.createElement("text");
		speedText.setAttribute("x", "668");
		speedText.setAttribute("y", "587");
		speedText.setAttribute("style",
				"font-family:Arial Unicode;font-size:18;");
		speedText.setAttribute("text-anchor", "middle");
		speedText.setAttribute("class", "noPress");
		speedText.appendChild(theText);
		controlGroup.appendChild(rect8);
		controlGroup.appendChild(speedText);

		Element rect9 = doc.createElement("rect");
		rect9.setAttribute("id", "SpeedPlusButton");
		rect9.setAttribute("x", "721");
		rect9.setAttribute("y", "570");
		rect9.setAttribute("width", "20");
		rect9.setAttribute("height", "20");
		rect9.setAttribute("rx", "5");
		rect9.setAttribute("ry", "5");
		rect9.setAttribute("class", "control");
		rect9.setAttribute("onclick", "speedPlus()");
		Element line3 = doc.createElement("line");
		line3.setAttribute("id", "line1SpeedPlusButton");
		line3.setAttribute("x1", "723");
		line3.setAttribute("x2", "739");
		line3.setAttribute("y1", "580");
		line3.setAttribute("y2", "580");
		line3.setAttribute("class", "control");
		line3.setAttribute("onclick", "speedPlus()");
		Element line4 = doc.createElement("line");
		line4.setAttribute("id", "line2SpeedPlusButton");
		line4.setAttribute("x1", "731");
		line4.setAttribute("x2", "731");
		line4.setAttribute("y1", "573");
		line4.setAttribute("y2", "587");
		line4.setAttribute("class", "control");
		line4.setAttribute("onclick", "speedPlus()");
		controlGroup.appendChild(rect9);
		controlGroup.appendChild(line3);
		controlGroup.appendChild(line4);

		Element rect10 = doc.createElement("rect");
		rect10.setAttribute("id", "SpeedMinusButton");
		rect10.setAttribute("x", "747");
		rect10.setAttribute("y", "570");
		rect10.setAttribute("width", "20");
		rect10.setAttribute("height", "20");
		rect10.setAttribute("rx", "5");
		rect10.setAttribute("ry", "5");
		rect10.setAttribute("class", "control");
		rect10.setAttribute("onclick", "speedMinus()");
		Element line5 = doc.createElement("line");
		line5.setAttribute("id", "line2SpeedMinusButton");
		line5.setAttribute("x1", "749");
		line5.setAttribute("x2", "765");
		line5.setAttribute("y1", "580");
		line5.setAttribute("y2", "580");
		line5.setAttribute("class", "control");
		line5.setAttribute("onclick", "speedMinus()");
		controlGroup.appendChild(rect10);
		controlGroup.appendChild(line5);
		mainGroup.appendChild(controlGroup);

		// binding image
		Element image = doc.createElement("image");
		image.setAttribute("id", "image");
		image.setAttribute("xlink:href", nameOutputFile + "-0.svg");
		image.setAttribute("width", imageWidth);

		image.setAttribute("height", imageHeight);
		image.setAttribute("x", "0");
		image.setAttribute("y", "40");
		mainGroup.appendChild(image);

		// generate the menu for different resolution
		Element resolutionMenu = doc.createElement("g");
		resolutionMenu.setAttribute("id", "resolutionMenu");
		resolutionMenu.setAttribute("class", "press");
		// menu under point 1 800x600 with animation
		Element resolution800x600 = doc.createElement("g");
		resolution800x600.setAttribute("id", "800x600");
		resolution800x600.setAttribute("onclick", "zoom(0.78125,0.78125)");
		Element rectM1 = menuRect(doc, 30);
		resolution800x600.appendChild(rectM1);
		Element text1 = menuText(doc, 41, "800x600");
		resolution800x600.appendChild(text1);
		resolutionMenu.appendChild(resolution800x600);

		// menu under point 2 1024x768 with animation
		Element resolution1024x768 = doc.createElement("g");
		resolution1024x768.setAttribute("id", "1024x768");
		resolution1024x768.setAttribute("onclick", "zoom(1,1)");
		Element rectM2 = menuRect(doc, 50);
		resolution1024x768.appendChild(rectM2);
		Element text2 = menuText(doc, 61, "1024x768");
		resolution1024x768.appendChild(text2);
		resolutionMenu.appendChild(resolution1024x768);

		// menu under point 3 1280x1024 with animation
		Element resolution1280x1024 = doc.createElement("g");
		resolution1280x1024.setAttribute("id", "1280x1024");
		resolution1280x1024.setAttribute("onclick", "zoom(1.25,1.33)");
		Element rectM3 = menuRect(doc, 70);
		resolution1280x1024.appendChild(rectM3);
		Element text3 = menuText(doc, 81, "1280x1024");
		resolution1280x1024.appendChild(text3);
		resolutionMenu.appendChild(resolution1280x1024);

		// menu under point 4 1400x1050 with animation
		Element resolution1400x1050 = doc.createElement("g");
		resolution1400x1050.setAttribute("id", "1400x1050");
		resolution1400x1050
				.setAttribute("onclick", "zoom(1.3671875,1.3671875)");
		Element rectM4 = menuRect(doc, 90);
		resolution1400x1050.appendChild(rectM4);
		Element text4 = menuText(doc, 101, "1400x1050");
		resolution1400x1050.appendChild(text4);
		resolutionMenu.appendChild(resolution1400x1050);

		// menu under point 5 1600x1200 with animation
		Element resolution1600x1200 = doc.createElement("g");
		resolution1600x1200.setAttribute("id", "1600x1200");
		resolution1600x1200.setAttribute("onclick", "zoom(1.5625,1.5625)");
		Element rectM5 = menuRect(doc, 110);
		resolution1600x1200.appendChild(rectM5);
		Element text5 = menuText(doc, 121, "1600x1200");
		resolution1600x1200.appendChild(text5);
		resolutionMenu.appendChild(resolution1600x1200);

		// menu under point 6 1920x1440 with animation
		Element resolution1920x1440 = doc.createElement("g");
		resolution1920x1440.setAttribute("id", "1920x1440");
		resolution1920x1440.setAttribute("onclick", "zoom(1.875,1.875)");
		Element rectM6 = menuRect(doc, 130);
		resolution1920x1440.appendChild(rectM6);
		Element text6 = menuText(doc, 141, "1920x1440");
		resolution1920x1440.appendChild(text6);
		resolutionMenu.appendChild(resolution1920x1440);

		// menu under point 7 2048x1536 with animation
		Element resolution2048x1536 = doc.createElement("g");
		resolution2048x1536.setAttribute("id", "2048x1536");
		resolution2048x1536.setAttribute("onclick", "zoom(2,2)");
		Element rectM7 = menuRect(doc, 150);
		resolution2048x1536.appendChild(rectM7);
		Element text7 = menuText(doc, 161, "2048x1536");
		resolution2048x1536.appendChild(text7);
		resolutionMenu.appendChild(resolution2048x1536);

		// menu under point close -- by click close the menu
		Element closeResolutionMenu = doc.createElement("g");
		closeResolutionMenu.setAttribute("id", "close");
		Element rectClose = topMenuRect(doc, 170, true);
		closeResolutionMenu.appendChild(rectClose);
		Element textClose = topMenuText(doc, 181, "close", true);
		closeResolutionMenu.appendChild(textClose);
		resolutionMenu.appendChild(closeResolutionMenu);

		mainGroup.appendChild(resolutionMenu);

		// top label of Menu
		Element menu = doc.createElement("g");
		menu.setAttribute("id", "menu");
		menu.setAttribute("class", "press");
		Element rectMenu = topMenuRect(doc, 0, false);
		menu.appendChild(rectMenu);
		Element textMenu = topMenuText(doc, 0, "resolution", false);
		menu.appendChild(textMenu);
		mainGroup.appendChild(menu);

		// adding everything to root
		svgRoot.appendChild(mainGroup);
		saveXML(doc, path + namePreviewSvg);
	}

	private Element menuRect(Document doc, long to) {
		Element rect1 = doc.createElement("rect");
		rect1.setAttribute("x", "15");
		rect1.setAttribute("y", "10");
		rect1.setAttribute("rx", "5");
		rect1.setAttribute("ry", "5");
		rect1.setAttribute("width", "50");
		rect1.setAttribute("height", "15");
		rect1.setAttribute("class", "control");
		Element animate1Rect1 = doc.createElement("animate");
		animate1Rect1.setAttribute("attributeName", "y");
		animate1Rect1.setAttribute("attributeType", "XML");
		animate1Rect1.setAttribute("begin", "menu.click");
		animate1Rect1.setAttribute("dur", "0.5s");
		animate1Rect1.setAttribute("from", "10");
		animate1Rect1.setAttribute("to", Long.toString(to));
		animate1Rect1.setAttribute("fill", "freeze");
		Element animate2Rect1 = doc.createElement("animate");
		animate2Rect1.setAttribute("attributeName", "y");
		animate2Rect1.setAttribute("attributeType", "XML");
		animate2Rect1.setAttribute("begin", "close.click");
		animate2Rect1.setAttribute("dur", "0.5s");
		animate2Rect1.setAttribute("from", Long.toString(to));
		animate2Rect1.setAttribute("to", "10");
		animate2Rect1.setAttribute("fill", "freeze");
		rect1.appendChild(animate1Rect1);
		rect1.appendChild(animate2Rect1);
		return rect1;
	}

	private Element menuText(Document doc, long to, String text) {
		Text rectText = doc.createTextNode(text);
		Element rectTextElement = doc.createElement("text");
		rectTextElement.setAttribute("x", "40");
		rectTextElement.setAttribute("y", "21");
		rectTextElement.setAttribute("class", "menuText");
		rectTextElement.setAttribute("text-anchor", "middle");
		rectTextElement.appendChild(rectText);
		// this animation is for popup the menu
		Element animation1RectTextElement = doc.createElement("animate");
		animation1RectTextElement.setAttribute("attributeName", "y");
		animation1RectTextElement.setAttribute("attributeType", "XML");
		animation1RectTextElement.setAttribute("begin", "menu.click");
		animation1RectTextElement.setAttribute("dur", "0.5s");
		animation1RectTextElement.setAttribute("from", "21");
		animation1RectTextElement.setAttribute("to", Long.toString(to));
		animation1RectTextElement.setAttribute("fill", "freeze");
		// this animation close the menu
		Element animation2RectTextElement = doc.createElement("animate");
		animation2RectTextElement.setAttribute("attributeName", "y");
		animation2RectTextElement.setAttribute("attributeType", "XML");
		animation2RectTextElement.setAttribute("begin", "close.click");
		animation2RectTextElement.setAttribute("dur", "0.5s");
		animation2RectTextElement.setAttribute("from", Long.toString(to));
		animation2RectTextElement.setAttribute("to", "21");
		animation2RectTextElement.setAttribute("fill", "freeze");
		rectTextElement.appendChild(animation1RectTextElement);
		rectTextElement.appendChild(animation2RectTextElement);
		return rectTextElement;
	}

	private Element topMenuRect(Document doc, long to, Boolean animation) {
		Element rect1 = doc.createElement("rect");
		rect1.setAttribute("x", "10");
		rect1.setAttribute("y", "10");
		rect1.setAttribute("rx", "5");
		rect1.setAttribute("ry", "5");
		rect1.setAttribute("width", "60");
		rect1.setAttribute("height", "15");
		rect1.setAttribute("class", "control");
		if (animation) {
			Element animate1Rect1 = doc.createElement("animate");
			animate1Rect1.setAttribute("attributeName", "y");
			animate1Rect1.setAttribute("attributeType", "XML");
			animate1Rect1.setAttribute("begin", "menu.click");
			animate1Rect1.setAttribute("dur", "0.5s");
			animate1Rect1.setAttribute("from", "10");
			animate1Rect1.setAttribute("to", Long.toString(to));
			animate1Rect1.setAttribute("fill", "freeze");
			Element animate2Rect1 = doc.createElement("animate");
			animate2Rect1.setAttribute("attributeName", "y");
			animate2Rect1.setAttribute("attributeType", "XML");
			animate2Rect1.setAttribute("begin", "close.click");
			animate2Rect1.setAttribute("dur", "0.5s");
			animate2Rect1.setAttribute("from", Long.toString(to));
			animate2Rect1.setAttribute("to", "10");
			animate2Rect1.setAttribute("fill", "freeze");
			rect1.appendChild(animate1Rect1);
			rect1.appendChild(animate2Rect1);
		}
		return rect1;
	}

	private Element topMenuText(Document doc, long to, String text,
			Boolean animation) {
		Text rectText = doc.createTextNode(text);
		Element rectTextElement = doc.createElement("text");
		rectTextElement.setAttribute("x", "40");
		rectTextElement.setAttribute("y", "21");
		rectTextElement.setAttribute("class", "special");
		rectTextElement.setAttribute("text-anchor", "middle");
		rectTextElement.appendChild(rectText);
		if (animation) {
			// this animation is for popup the menu
			Element animation1RectTextElement = doc.createElement("animate");
			animation1RectTextElement.setAttribute("attributeName", "y");
			animation1RectTextElement.setAttribute("attributeType", "XML");
			animation1RectTextElement.setAttribute("begin", "menu.click");
			animation1RectTextElement.setAttribute("dur", "0.5s");
			animation1RectTextElement.setAttribute("from", "21");
			animation1RectTextElement.setAttribute("to", Long.toString(to));
			animation1RectTextElement.setAttribute("fill", "freeze");
			// this animation close the menu
			Element animation2RectTextElement = doc.createElement("animate");
			animation2RectTextElement.setAttribute("attributeName", "y");
			animation2RectTextElement.setAttribute("attributeType", "XML");
			animation2RectTextElement.setAttribute("begin", "close.click");
			animation2RectTextElement.setAttribute("dur", "0.5s");
			animation2RectTextElement.setAttribute("from", Long.toString(to));
			animation2RectTextElement.setAttribute("to", "21");
			animation2RectTextElement.setAttribute("fill", "freeze");
			rectTextElement.appendChild(animation1RectTextElement);
			rectTextElement.appendChild(animation2RectTextElement);
		}
		return rectTextElement;
	}
}
